\documentclass{article}
\usepackage[utf8]{inputenc}
\usepackage{amsmath, amsthm, amssymb}
\newtheorem{thm}{Theorem}
\newtheorem{dfn}[thm]{Definition}
\newtheorem{lem}[thm]{Lemma}
\newtheorem{exm}[thm]{Example}

\begin{document}
Some preliminary text.

\begin{thm}
The first theorem.  
\end{thm}

\begin{proof}
A proof environment,
including a mark for the end of the proof.  
\end{proof}

\begin{thm}
A second theorem.  
\end{thm}

\begin{dfn}
A first definition.  
\end{dfn}

\begin{exm}
Time for an example.  
\end{exm}
\end{document}     
